/**
 * @file
 * VuoList_VuoMidiDevice C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMidiDevice_H
#define VuoList_VuoMidiDevice_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMidiDevice VuoList_VuoMidiDevice
 * A list of @ref VuoMidiDevice elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoMidiDevice
 * A list of @ref VuoMidiDevice elements.
 */
#ifndef VuoList_VuoMidiDevice_TYPE_DEFINED
typedef void * VuoList_VuoMidiDevice;
#endif

/**
 * Creates a new list of @ref VuoMidiDevice elements.
 */
VuoList_VuoMidiDevice VuoListCreate_VuoMidiDevice(void);

/**
 * Returns the @ref VuoMidiDevice at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMidiDevice VuoListGetValueAtIndex_VuoMidiDevice(const VuoList_VuoMidiDevice list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMidiDevice(VuoList_VuoMidiDevice list, const VuoMidiDevice value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMidiDevice(VuoList_VuoMidiDevice list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMidiDevice(VuoList_VuoMidiDevice list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMidiDevice(const VuoList_VuoMidiDevice list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMidiDevice VuoList_VuoMidiDevice_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMidiDevice_jsonFromValue(const VuoList_VuoMidiDevice value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMidiDevice_summaryFromValue(const VuoList_VuoMidiDevice value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMidiDevice VuoList_VuoMidiDevice_valueFromString(const char *str);
char * VuoList_VuoMidiDevice_stringFromValue(const VuoList_VuoMidiDevice value);
/// @}

/**
 * @}
 */

#endif
